<?php
/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/Resources/Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */


$listViewDefs ['Leads'] =
    array (
        'NAME' =>
            array (
                'width' => '10',
                'label' => 'LBL_LIST_NAME',
                'link' => true,
                'orderBy' => 'name',
                'default' => true,
                'related_fields' =>
                    array (
                        0 => 'first_name',
                        1 => 'last_name',
                        2 => 'salutation',
                    ),
            ),
        'STATUS' =>
            array (
                'width' => '7',
                'label' => 'LBL_LIST_STATUS',
                'default' => true,
            ),
        'ACCOUNT_NAME' =>
            array (
                'width' => '15',
                'label' => 'LBL_LIST_ACCOUNT_NAME',
                'default' => true,
                'related_fields' =>
                    array (
                        0 => 'account_id',
                    ),
            ),
        'PHONE_WORK' =>
            array (
                'width' => '15',
                'label' => 'LBL_LIST_PHONE',
                'default' => true,
            ),
        'EMAIL' =>
            array (
                'width' => '16',
                'label' => 'LBL_LIST_EMAIL_ADDRESS',
                'sortable' => false,
                'customCode' => '{$EMAIL_LINK}{$EMAIL}</a>',
                'default' => true,
            ),
        'ASSIGNED_USER_NAME' =>
            array (
                'width' => '5',
                'label' => 'LBL_LIST_ASSIGNED_USER',
                'module' => 'Employees',
                'id' => 'ASSIGNED_USER_ID',
                'default' => true,
            ),
        'TITLE' =>
            array (
                'width' => '10',
                'label' => 'LBL_TITLE',
                'default' => false,
            ),
        'REFERED_BY' =>
            array (
                'width' => '10',
                'label' => 'LBL_REFERED_BY',
                'default' => false,
            ),
        'LEAD_SOURCE' =>
            array (
                'width' => '10',
                'label' => 'LBL_LEAD_SOURCE',
                'default' => false,
            ),
        'DEPARTMENT' =>
            array (
                'width' => '10',
                'label' => 'LBL_DEPARTMENT',
                'default' => false,
            ),
        'DO_NOT_CALL' =>
            array (
                'width' => '10',
                'label' => 'LBL_DO_NOT_CALL',
                'default' => false,
            ),
        'PHONE_HOME' =>
            array (
                'width' => '10',
                'label' => 'LBL_HOME_PHONE',
                'default' => false,
            ),
        'PHONE_MOBILE' =>
            array (
                'width' => '10',
                'label' => 'LBL_MOBILE_PHONE',
                'default' => false,
            ),
        'PHONE_OTHER' =>
            array (
                'width' => '10',
                'label' => 'LBL_OTHER_PHONE',
                'default' => false,
            ),
        'PHONE_FAX' =>
            array (
                'width' => '10',
                'label' => 'LBL_FAX_PHONE',
                'default' => false,
            ),
        'PRIMARY_ADDRESS_COUNTRY' =>
            array (
                'width' => '10',
                'label' => 'LBL_PRIMARY_ADDRESS_COUNTRY',
                'default' => false,
            ),
        'PRIMARY_ADDRESS_STREET' =>
            array (
                'width' => '10',
                'label' => 'LBL_PRIMARY_ADDRESS_STREET',
                'default' => false,
            ),
        'PRIMARY_ADDRESS_CITY' =>
            array (
                'width' => '10',
                'label' => 'LBL_PRIMARY_ADDRESS_CITY',
                'default' => false,
            ),
        'PRIMARY_ADDRESS_STATE' =>
            array (
                'width' => '10',
                'label' => 'LBL_PRIMARY_ADDRESS_STATE',
                'default' => false,
            ),
        'PRIMARY_ADDRESS_POSTALCODE' =>
            array (
                'width' => '10',
                'label' => 'LBL_PRIMARY_ADDRESS_POSTALCODE',
                'default' => false,
            ),
        'ALT_ADDRESS_COUNTRY' =>
            array (
                'width' => '10',
                'label' => 'LBL_ALT_ADDRESS_COUNTRY',
                'default' => false,
            ),
        'ALT_ADDRESS_STREET' =>
            array (
                'width' => '10',
                'label' => 'LBL_ALT_ADDRESS_STREET',
                'default' => false,
            ),
        'ALT_ADDRESS_CITY' =>
            array (
                'width' => '10',
                'label' => 'LBL_ALT_ADDRESS_CITY',
                'default' => false,
            ),
        'ALT_ADDRESS_STATE' =>
            array (
                'width' => '10',
                'label' => 'LBL_ALT_ADDRESS_STATE',
                'default' => false,
            ),
        'ALT_ADDRESS_POSTALCODE' =>
            array (
                'width' => '10',
                'label' => 'LBL_ALT_ADDRESS_POSTALCODE',
                'default' => false,
            ),
        'CREATED_BY' =>
            array (
                'width' => '10',
                'label' => 'LBL_CREATED',
                'default' => false,
            ),
        'TEAM_NAME' =>
            array (
                'width' => '5',
                'label' => 'LBL_LIST_TEAM',
                'default' => false,
            ),
        'MODIFIED_BY_NAME' =>
            array (
                'width' => '5',
                'label' => 'LBL_MODIFIED',
                'default' => false,
            ),
        'DATE_ENTERED' =>
            array (
                'width' => '10',
                'label' => 'LBL_DATE_ENTERED',
                'default' => true,
            ),
    );
