<?php
/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/Resources/Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

$viewdefs['Opportunities']['base']['filter']['default'] = array(
    'default_filter' => 'all_records',
    'fields' => array(
        'name' => array(),
        'account_name' => array(),
        'amount' => array(),
        'renewal' => array(),
        'next_step' => array(),
        'probability' => array(),
        'lead_source' => array(),
        'opportunity_type' => array(),
        'sales_stage' => array(),
        'date_entered' => array(),
        'date_modified' => array(),
        'date_closed' => array(),
        'service_duration' => [
            'dbFields' => [
                'service_duration_value',
                'service_duration_unit',
            ],
            'vname' => 'LBL_SERVICE_DURATION',
            'type' => 'text',
        ],
        'tag' => array(),
        'assigned_user_name' => array(),
        '$owner' => array(
            'predefined_filter' => true,
            'vname' => 'LBL_CURRENT_USER_FILTER',
        ),
        '$favorite' => array(
            'predefined_filter' => true,
            'vname' => 'LBL_FAVORITES_FILTER',
        ),
        '$distance' => [
            'name' => '$distance',
            'vname' => 'LBL_MAPS_DISTANCE',
            'type' => 'maps-distance',
            'source' => 'non-db',
            'merge_filter' => 'enabled',
            'licenseFilter' => ['MAPS'],
        ],
        'is_escalated' => [],
        'forecasted_likely' => [],
        'commit_stage' => [],
        'lost' => [],
        'team_name' => [],
        'modified_by_name' => [],
        'created_by_name' => [],
    ),
);
