<?php

/*
 * Your installation or use of this SugarCRM file is subject to the applicable
 * terms available at
 * http://support.sugarcrm.com/Resources/Master_Subscription_Agreements/.
 * If you do not agree to all of the applicable terms or do not have the
 * authority to bind the entity as an authorized representative, then do not
 * install or use this SugarCRM file.
 *
 * Copyright (C) SugarCRM Inc. All rights reserved.
 */

use Sugarcrm\Sugarcrm\IdentityProvider\Authentication;

$idpConfig = new Authentication\Config(\SugarConfig::getInstance());

$viewdefs['Users']['base']['layout']['sidebar-nav-flyout-module-menu'] = [
    'cloudConsoleLink' => $idpConfig->isIDMModeEnabled() ? $idpConfig->buildCloudConsoleUrl('userCreate') : '',
    'collectionSettings' => [
        'recently_viewed' => [
            'filter' => [
                '$tracker' => '-7 DAY',
            ],
            'icon' => 'sicon-clock',
            'limit' => 3,
        ],
        'favorites' => [
            'filter' => [
                '$favorite' => '',
            ],
            'icon' => 'sicon-star-fill',
            'limit' => 3,
        ],
    ],
];
